//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// C Source File
// Created 23/10/03; 16:18:14

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

#include "filterlib.h"
#include "ftfrdr.h"

//--------------------------------------------------------------------------

extern int (*IsFilterSym)(SYM_ENTRY*SymPtr);

//--------------------------------------------------------------------------

unsigned short FileSize;

int paragraph;
int paragraph_count;
int page_num;
int page_count;


char *FilePtr;
TPoint PrintfPos;
char filename[10];

char* OffSetPos[MAX_PRG];
char* PagePos[MAX_PAGE];

//--------------------------------------------------------------------------


void InputStr (char *buffer, short maxlen)
{
  SCR_STATE ss;
  short key, i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer);
        // Note that two spaces are required if F_4x6 font is used
      key = ngetchx ();
      if (key >= ' ' && key <= '~' && i < maxlen) buffer[i++] = key;
      if (key == KEY_BACKSPACE && i) i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER);
}


//--------------------------------------------------------------------------

int Is_FTFRDR(SYM_ENTRY*SymPtr)
{

unsigned char *ptr=SymPtrAdress(SymPtr);

if (memcmp(ptr,"FTFRDR",6)==0)
return 1;
else
return 0;

}
//--------------------------------------------------------------------------


void MakeOffsets(void)
{

int paragraph=0;
char*ptr=0;

for (;;)
{

char*absptr=(char*)((unsigned long)FilePtr+(unsigned long)ptr);

if (*absptr=='#')
OffSetPos[paragraph++]=absptr;

if (paragraph>=MAX_PRG)
break;
if (((unsigned long)ptr)>=FileSize)
break;

ptr++;

}

paragraph_count=paragraph;

}
//--------------------------------------------------------------------------

void clrscrF(void)
{
clrscr();
printf("%s, PAR. %d, PAGE %d",filename,paragraph,page_num+1);

PrintfPos.x=0;
PrintfPos.y=12;

}
//--------------------------------------------------------------------------

void PutRET(void)
{

PrintfPos.x=0;
PrintfPos.y+=6;

/*
if (PrintfPos.y>=(LCD_HEIGHT-6))
{
while (ngetchx()!=KEY_ENTER);
page_num++;
clrscrF();
}
*/

}
//--------------------------------------------------------------------------

void DisplayText(void)
{

char str_width[2]="";


if (page_num<0)
page_num=0;
if (page_num>(page_count-1))
page_num=(page_count-1);

clrscrF();

char*ptr=PagePos[page_num];

for (;;)
{

if (*ptr=='#')
{
page_count=page_num+1;
break;
}

if (ptr==(FilePtr+FileSize-6))
{
break;
}

if (PrintfPos.y>=(LCD_HEIGHT-6))
{
PagePos[page_num+1]=ptr;
break;
}

if (*ptr==0x0D)
{
ptr++;
continue;
}

//putchar(*ptr);
if (*ptr==0x0A)
{
ptr++;
PutRET();
continue;
}

*str_width=*ptr;
int char_width=DrawStrWidth (str_width,0);

if ((PrintfPos.x+char_width)>=(LCD_WIDTH))
{
PutRET();
continue;
}

DrawChar(PrintfPos.x,PrintfPos.y,*ptr,A_NORMAL);
PrintfPos.x+=char_width;

ptr++;

}


//ngetchx();

}
//--------------------------------------------------------------------------

void LoadParagraph(void)
{

if (paragraph<0)
paragraph=0;
if (paragraph>(paragraph_count-1))
paragraph=(paragraph_count-1);

page_num=0;
page_count=MAX_PAGE;

memset(PagePos,0,sizeof(PagePos));

PagePos[page_num]=OffSetPos[paragraph]+1;

DisplayText();

}
//--------------------------------------------------------------------------

// Main Function
void _main(void)
{


int key;

FontSetSys(0);

randomize();



FontSetSys(0);
clrscr();
printf("Fighting Fantasy Reader 1.1 \n");
printf("Programmed by Olivier Sangala \n");
printf("http://olivier.sangala.free.fr \n");
printf("olivier_sangala@hotmail.com \n");
FontSetSys(1);
ngetchx();



IsFilterSym=Is_FTFRDR;
SYM_ENTRY*SymPtr=SymFindFirstF();


if (!SymPtr)
{
clrscr();
printf("No File Found.");
ngetchx();
return;
}


for (;;)
{
	clrscr();
	printf("Select File : < %s >  \n\n",SymPtr->name);
	key = ngetchx();
	
	if (key==KEY_LEFT)
	SymPtr=SymFindPrevF();
	else if (key==KEY_RIGHT)
	SymPtr=SymFindNextF();
	else if (key==KEY_ENTER)
	break;
	else if (key==KEY_ESC)
	return;

}


strcpy(filename,SymPtr->name);

FilePtr=FilePointer(SymPtr->name);
FileSize=FileLength(SymPtr->name);

printf("Loading... \n");
MakeOffsets();
printf("FileName : %s \n",SymPtr->name);
printf("Paragraphs : %d \n",paragraph_count);
printf("Press any key... \n");
ngetchx();




paragraph=0;

LoadParagraph();

for (;;)
{


key = ngetchx();


if (key==KEY_F1)
{

clrscr();
printf("Goto Paragraph : \n");

char buffer[16];
InputStr(buffer,3);
int p=atoi(buffer);

paragraph=p;
LoadParagraph();

}

else if (key==KEY_F2)
{
clrscr();
printf("Rolling One Dice (1-6) : %d \n",random(6)+1);
printf("Press any key... \n");
ngetchx();

DisplayText();
}

else if (key==KEY_F3)
{
clrscr();
printf("Rolling Two Dices (1-6) : %d and %d \n",random(6)+1,random(6)+1);
printf("Press any key... \n");
ngetchx();

DisplayText();
}


else if (key==KEY_UP)
{
page_num--;
DisplayText();
}

else if (key==KEY_DOWN)
{
page_num++;
DisplayText();
}


else if (key=='*')
{
LoadParagraph();
}

else if (key=='-')
{
paragraph--;
LoadParagraph();
}

else if (key=='+')
{
paragraph++;
LoadParagraph();
}

else if (key==KEY_APPS)
{
	off();
}

else if (key==KEY_ESC)
{
	break;
}

}




}
